/*
 * gshare.java
 *
 * Copyright (c) 2004 Rutgers, The State University of New Jersey
 *
 * Daniel A. Jimnez
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT.  IN NO EVENT SHALL RUTGERS, THE STATE UNIVERSITY
 * OF NEW JERSEY BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 */

// quick-and-dirty gshare implementation

public class gshare extends branch_predictor {

	public class gshare_update extends branch_update {
		int index;
	};

	static final int lgtabsize = 12;
	static final int tabsize = 1 << lgtabsize;
	int history = 0;
	int	table[];

	gshare () { 
		table = new int[tabsize];
		for (int i=0; i<tabsize; i+=2) {
			table[i] = 1;
			table[i+1] = 2;
		}
	}

	branch_update predict (int address) {
		gshare_update u = new gshare_update();
		int index = (address & 0x7fffffff) ^ (history & 0x7fffffff);
		index %= tabsize;
		u.index = index;
		u.set_prediction (table[index] >= 2);
		return u;
	}

	void update (branch_update bu, boolean taken) {
		gshare_update u = (gshare_update) bu;
		if (taken) {
			if (table[u.index] < 3) table[u.index]++;
		} else {
			if (table[u.index] > 0) table[u.index]--;
		}
		history <<= 1;
		if (taken) history++;
	}
};
